-- execute, e.g., via "$ runghc L11.hs"
module Main where

firstIndex :: (a -> Bool) -> [a] -> Int
firstIndex p =
  fst . -- obtain first component (= index) of resulting pair
  head . -- take first pair
  filter (p . snd) . -- only keep pairs satisfying "p"
  zip [0..] -- pair list elements with 0-based indices

main = do
  let f1 x = x + 1
      f2 x = f2 x
  input <- getLine
  let i = read input
  print $ head [f1 i, f2 i]
