module Main where
import Data.List

length' :: Integer -> [a] -> Integer
length' acc []     = acc
length' acc (_:xs) = length' (acc + 1) xs

-- length'' acc []     = acc
-- length'' acc (_:xs) = acc `seq` length'' (acc + 1) xs
length'' = foldl' (const . (+1))

main = do
  let n = 50000000
  putStrLn $ "computing lenght'' (" ++ show n ++ ")"
  print $ length'' 0 [0..n]
  -- needs more than 4 GB of RAM
  putStrLn $ "computing length' (" ++ show n ++ ")"
  print $ length' 0 [0..n]
